import numpy as np
import os
import shutil

#function to save xvg into arrays
#open the xvg, print needed info in txt 
#nondata line start with # or @
#find returns -1 if false
#create an empty list to be appended
#count the number of lines to get the array size
#split each line into a list and save into another list
#create an empty array of the right size then fill with the list
#this is faster than appending an np array
#T switches rows and columns
#this will be necessary for averaging once all data is gathered

c = 0
def xvg_array (info):
    xvg = info + ".xvg"
    txt = info + ".txt"
    with open( xvg,'r') as file:
        lines = file.readlines()
    with open( txt,'w') as file:
        for line in lines:
            if line.find("#") != -1:
                pass
            elif line.find("@") != -1:
                pass
            else:
                file.write(line)
    rdf_file_l = []
    global c 
    c = 0
    with open( txt, 'r') as file:
        lines = file.readlines()
        for line in lines:     
            value = line.split()  
            rdf_file_l.append(value)
            c = c + 1
    rdf_file_a = np.zeros((c,3))
    rdf_file_a = np.array(list(rdf_file_l), float)
    rdf_file_a = rdf_file_a.T
    return(rdf_file_a)

#runs xvg_array for each of ten files and saves into 1 array
#averages these and makes a new array containing the average
#write a new xvg file with the header from file 1
#then puts the averaged array in it 
rdf_ave = np.array((0,0,0))
fold_rdf = os.environ["PROD"] + "/analysis/rdf/"
fold_int = fold_rdf + "intra/"	
def averaging (residue):

    name_nmol = residue + "NMOL"
    nmol = int(os.environ[name_nmol])
    print(nmol)

    if nmol < 10:
        num = [num + 1 for num in range(nmol)]
        rdf_res_l = []
        rdf_res_a = np.zeros((nmol, 3, c))
        for i in num:
            inp = fold_int + "rdf_" + residue + "_intra_" + str(i)
            out = xvg_array(inp)
            rdf_res_l.append(out)  
    else:
        num = [num + 1 for num in range(10)]
        rdf_res_l = []
        rdf_res_a = np.zeros((10, 3, c)) 
        for i in num:
            inp = fold_int + "rdf_" + residue + "_intra_" + str(i)
            out = xvg_array(inp)
            rdf_res_l.append(out)   
#this chunk does the averaging
    global rdf_ave
    rdf_res_a = np.array(list(rdf_res_l), float)
    rdf_ave = rdf_res_a.mean(axis = 0)
    rdf_ave = np.round(rdf_ave, 3)

    x = [x for x in range(c)]
    header = fold_int + "rdf_" + residue + "_intra_1.xvg"
    with open(header, 'r') as file:
        lines = file.readlines()
    avefile = fold_rdf + "rdf_" + residue + "_intra_ave.xvg"
    with open(avefile, 'w+') as file:
        for line in lines:
            if line.find("#") != -1:
                file.write(line)
            elif line.find("@") != -1:
                file.write(line)
#these lines write the array into an xvg
#calculate integrals and normalize as they are entered?
        for v in x:
            dist = str(rdf_ave[0,v])
            alc = str(rdf_ave[1,v])
            ether = str(rdf_ave[2,v])
            content = "      " + dist + "    " + alc + "    " + ether + '\n'
            file.write(content)

#calculates inter_same by subtracting intra from total
#intra must be scaled by dividing by nmol 
#then the header is copied from the total file 
#and data added
fold_tot = fold_rdf + "total/"
def inter (residue):
    inp = fold_tot + "rdf_" + residue + "_total"
    rdf_total = xvg_array(inp)
    name_nmol = residue + "NMOL"
    nmol = int(os.environ[name_nmol])
    rdf_intra = (rdf_ave / nmol) 
    rdf_inter = (rdf_total - rdf_intra)
    rdf_inter = np.round(rdf_inter, 3) 

    x = [x for x in range(c)]
    header = fold_tot + "rdf_" + residue + "_total.xvg"
    with open(header, 'r') as file:
        lines = file.readlines()
    intfile = fold_rdf + "rdf_" + residue + "_inter_same.xvg"
    with open(intfile, 'w+') as file:
        for line in lines:
            if line.find("#") != -1:
                file.write(line)
            elif line.find("@") != -1:
                file.write(line)
        for v in x:
            dist = str(rdf_total[0,v])
            alc = str(rdf_inter[1,v])
            ether = str(rdf_inter[2,v])
            content = "      " + dist + "    " + alc + "    " + ether + '\n'
            file.write(content)

#input is provided through a shell file
#run both averging and inter for each residue
res_name = input("residue?")
averaging(res_name)
inter(res_name)



